﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using static Infragistics.Windows.DataPresenter.DataPresenterBase;

namespace GridSample
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();


            ObservableCollection<SampleRecord> records = new ObservableCollection<SampleRecord>();
            records.Add(new SampleRecord()
            {
                Name = "A",
                Number1 = 1000,
                Number2 = 2000,
            });
            records.Add(new SampleRecord()
            {
                Name = "B",
                Number1 = 7000,
                Number2 = 6000,
            });

            records.Add(new SampleRecord()
            {
                Name = "C",
                Number1 = 4000,
                Number2 = 5000,
            });
            this.xamDataGrid.DataSource = records;
        }


        private void xamDataGrid_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {
            int cellCount = 0;
            int cellCountOfTypeNumber = 0;
            decimal average = 0;
            decimal sum = 0;

            foreach (var cell in xamDataGrid.SelectedItems.Cells)
            {
                if (cell.Value != null)
                {
                    // 値があるセルであれば、カウントを増やす
                    cellCount += 1;
                    decimal addSum = 0;
                    // 数値項目か判定
                    if (Decimal.TryParse(cell.Value.ToString(), out addSum))
                    {
                        // 平均値を算出するため、数値型のセルのカウントを行う
                        cellCountOfTypeNumber += 1;
                        // 合計値を加算
                        sum += addSum;
                    }
                }
            }
            //  選択されたセルの情報を、各項目に反映する
            if (cellCountOfTypeNumber >= 1)
            {
                average = sum / cellCountOfTypeNumber;
            }
            lblAverage.Text = string.Format("平均 : {0:#,0}", average);
            lblCount.Text = string.Format("データの個数 : {0}", cellCount);
            lblSum.Text = string.Format("合計 : {0:#,0}", sum);
        }

    }
}
